Package com.complexible.stardog.metadata

# Class MetaProperty.Builder<T,P extends MetaProperty<T>>

java.lang.Object
com.complexible.stardog.metadata.MetaProperty.Builder<T,P>

Enclosing class:
  `MetaProperty<T>`

public static class MetaProperty.Builder<T,P extends MetaProperty<T>> extends Object
The builder class for building an option instance.

Author:
  Evren Sirin

- ## Method Summary

  Modifier and Type
  Method
  Description
  `P`
  `build()`
  `MetaProperty.Builder<T,P>`
  `byteIO(com.complexible.stardog.metadata.ByteIO<T> theByteIO)`
  `MetaProperty.Builder<T,P>`
  `category(com.complexible.stardog.metadata.OptionsCategory theCategory)`
  Sets the category for this property.
  `MetaProperty.Builder<T,P>`
  `category(String theCategoryName)`
  Deprecated.
  Use `category(OptionsCategory)` instead.
  `MetaProperty.Builder<T,P>`
  `creatable()`
  `MetaProperty.Builder<T,P>`
  `database()`
  `MetaProperty.Builder<T,P>`
  `description(String theDescription)`
  `MetaProperty.Builder<T,P>`
  `diskIndex()`
  `MetaProperty.Builder<T,P>`
  `graphIO(com.complexible.stardog.metadata.GraphIO<T> theGraphIO)`
  `MetaProperty.Builder<T,P>`
  `index()`
  `MetaProperty.Builder<T,P>`
  `label(String theLabel)`
  `MetaProperty.Builder<T,P>`
  `memoryIndex()`
  `MetaProperty.Builder<T,P>`
  `nonsecure()`
  Mark this property as non-secure which means it will not require database metadata permissions to read its value.
  `MetaProperty.Builder<T,P>`
  `possibleValues(Collection<T> theValues)`
  `MetaProperty.Builder<T,P>`
  `readable()`
  `MetaProperty.Builder<T,P>`
  `secure()`
  `MetaProperty.Builder<T,P>`
  `server()`
  `MetaProperty.Builder<T,P>`
  `systemDefaultValue(T theValue)`
  `MetaProperty.Builder<T,P>`
  `temporary()`
  Marks this property as temporary.
  `MetaProperty.Builder<T,P>`
  `textIO(com.complexible.stardog.metadata.TextIO<T> theTextIO)`
  `MetaProperty.Builder<T,P>`
  `writable()`
  `MetaProperty.Builder<T,P>`
  `writableWhileOnline()`

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Method Details

  - ### secure

    public MetaProperty.Builder<T,P> secure()

  - ### nonsecure

    public MetaProperty.Builder<T,P> nonsecure()
    Mark this property as non-secure which means it will not require database metadata permissions to read its value. Database read/write permissions will still be required to read its value. Database metadata write permission is required to update any property regardless of this value.

  - ### byteIO

    public MetaProperty.Builder<T,P> byteIO(com.complexible.stardog.metadata.ByteIO<T> theByteIO)

  - ### textIO

    public MetaProperty.Builder<T,P> textIO(com.complexible.stardog.metadata.TextIO<T> theTextIO)

  - ### graphIO

    public MetaProperty.Builder<T,P> graphIO(com.complexible.stardog.metadata.GraphIO<T> theGraphIO)

  - ### readable

    public MetaProperty.Builder<T,P> readable()

  - ### creatable

    public MetaProperty.Builder<T,P> creatable()

  - ### writable

    public MetaProperty.Builder<T,P> writable()

  - ### writableWhileOnline

    public MetaProperty.Builder<T,P> writableWhileOnline()

  - ### server

    public MetaProperty.Builder<T,P> server()

  - ### database

    public MetaProperty.Builder<T,P> database()

  - ### index

    public MetaProperty.Builder<T,P> index()

  - ### diskIndex

    public MetaProperty.Builder<T,P> diskIndex()

  - ### memoryIndex

    public MetaProperty.Builder<T,P> memoryIndex()

  - ### temporary

    public MetaProperty.Builder<T,P> temporary()
    Marks this property as temporary. Temporary properties are never serialized and only stay in memory. This means they would not be sent from client to server either since that requires serialization.

  - ### label

    public MetaProperty.Builder<T,P> label(String theLabel)

  - ### description

    public MetaProperty.Builder<T,P> description(String theDescription)

  - ### category

    public MetaProperty.Builder<T,P> category(com.complexible.stardog.metadata.OptionsCategory theCategory)
    Sets the category for this property. Categories group related properties by the functionality they configure, such as "Database", "Query", "Reasoning", etc. This grouping is used for organizing properties in documentation.
    Parameters:
      `theCategory` - the category
    Returns:
      this builder for method chaining

  - ### category

    @Deprecated public MetaProperty.Builder<T,P> category(String theCategoryName)
    Deprecated.
    Use `category(OptionsCategory)` instead.

  - ### systemDefaultValue

    public MetaProperty.Builder<T,P> systemDefaultValue(T theValue)

  - ### possibleValues

    public MetaProperty.Builder<T,P> possibleValues(Collection<T> theValues)

  - ### build

    public P build()